//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
 
    
    public partial class Inactivity
    {
		private static Timer m_timer;
		private int MouseX = -1;
		private int MouseY = -1;
		private int MouseMoved = 0;
		
		
		void Inactivity_Created(System.Object sender, System.EventArgs e)
		{
			// Set up timer that monitors if the mouse has moved
			m_timer = new Timer();
			m_timer.Interval = 1000;
			m_timer.Tick += TimerTick;
			m_timer.Enabled = true;			
		}
		
		private void TimerTick(System.Object sender, System.EventArgs e)
		{
			int x = System.Windows.Forms.Control.MousePosition.X;
			int y = System.Windows.Forms.Control.MousePosition.Y;
			int InactTime = Globals.Tags.InactivityTimeout.Value;
						
			if( ( Math.Abs(MouseX-x) > 5 ) || ( Math.Abs(MouseY-y) > 5 ) )
			{
				// Reset number of seconds since mouse moved
				MouseMoved=0;	
				// Reset flag and background brightness
				Globals.Tags.Inactive.Value = 0;					
				Globals.Tags.SystemTagBacklightBrightnessLevel.SetAnalog(100);
			}
			else
			{
				// Increment number of seconds since the mouse moved
				MouseMoved++;
				
				// Check if we want the inactivity function to be active and
				// if mouse hasn't been moved for a specific time
				if((InactTime>0) && (MouseMoved > Globals.Tags.InactivityTimeout.Value))
				{
					// Set flag to indicate that inactivity has occured
					Globals.Tags.Inactive.Value = 1;
					
					// Turn off background brigtness
					Globals.Tags.SystemTagBacklightBrightnessLevel.SetAnalog(0);
					
				// Alternate code to logout user if screen is inactive
					// Show logout screen, if we are logged in
/*					
					if( Globals.Tags.SystemTagCurrentUser.Value != string.Empty)
					{
						Globals.Security.Logout();
						Globals.LoggedOut.Show();					
					}
*/					

					//Show this screen if a timeout occurs. Comment out for logout version.
					Globals.TimedOut.Show();
				
				}
			}			
			MouseX = x;
			MouseY = y;
		}
    }
}
